// Generated by psc version 0.10.2
"use strict";
var $foreign = require("./foreign");
var Prelude = require("../Prelude");
var Data_Argonaut_Printer = require("../Data.Argonaut.Printer");
var Data_Argonaut_Parser = require("../Data.Argonaut.Parser");
var Data_Argonaut_Decode = require("../Data.Argonaut.Decode");
var Data_Argonaut_Encode = require("../Data.Argonaut.Encode");
var Data_Array = require("../Data.Array");
var Data_DateTime_Instant = require("../Data.DateTime.Instant");
var Data_Either = require("../Data.Either");
var Data_Foldable = require("../Data.Foldable");
var Data_Traversable = require("../Data.Traversable");
var Data_StrMap = require("../Data.StrMap");
var Data_StrMap_ST = require("../Data.StrMap.ST");
var Data_Maybe = require("../Data.Maybe");
var Data_Set = require("../Data.Set");
var Data_String = require("../Data.String");
var Control_Monad_Eff = require("../Control.Monad.Eff");
var Control_Monad_Eff_Console = require("../Control.Monad.Eff.Console");
var Control_Monad_Eff_Exception = require("../Control.Monad.Eff.Exception");
var Control_Monad_Eff_Now = require("../Control.Monad.Eff.Now");
var Control_Monad_ST = require("../Control.Monad.ST");
var Node_Platform = require("../Node.Platform");
var Node_Process = require("../Node.Process");
var Node_ChildProcess = require("../Node.ChildProcess");
var Node_Stream = require("../Node.Stream");
var Node_Buffer = require("../Node.Buffer");
var Node_Encoding = require("../Node.Encoding");
var Node_FS = require("../Node.FS");
var Node_FS_Sync = require("../Node.FS.Sync");
var Node_FS_Stats = require("../Node.FS.Stats");
var Node_Path = require("../Node.Path");
var Unsafe_Coerce = require("../Unsafe.Coerce");
var Partial_Unsafe = require("../Partial.Unsafe");
var Psa = require("../Psa");
var Psa_Printer_Default = require("../Psa.Printer.Default");
var Psa_Printer_Json = require("../Psa.Printer.Json");
var Data_Eq = require("../Data.Eq");
var Data_HeytingAlgebra = require("../Data.HeytingAlgebra");
var Control_Apply = require("../Control.Apply");
var Control_Applicative = require("../Control.Applicative");
var Data_Ord = require("../Data.Ord");
var Data_Boolean = require("../Data.Boolean");
var Data_Functor = require("../Data.Functor");
var Control_Bind = require("../Control.Bind");
var Data_Function = require("../Data.Function");
var Data_Semigroup = require("../Data.Semigroup");
var Data_Show = require("../Data.Show");
var Data_Posix_Signal = require("../Data.Posix.Signal");
var Control_Semigroupoid = require("../Control.Semigroupoid");
var Data_DateTime = require("../Data.DateTime");
var Data_Ring = require("../Data.Ring");
var Data_Argonaut_Encode_Class = require("../Data.Argonaut.Encode.Class");
var Psa_Types = require("../Psa.Types");
var Data_Argonaut_Decode_Class = require("../Data.Argonaut.Decode.Class");
var Psa_Output = require("../Psa.Output");
var usage = "psa - Error/Warning reporting frontend for psc\n\nUsage: psa [--censor-lib] [--censor-src]\n           [--censor-codes=CODES] [--filter-codes=CODES]\n           [--no-colors] [--no-source]\n           [--is-lib=DIR] [--psc=PSC] [--stash]\n           PSC_OPTIONS\n\nAvailable options:\n  -v,--version           Show the version number\n  -h,--help              Show this help text\n  --verbose-stats        Show counts for each warning type\n  --censor-warnings      Censor all warnings\n  --censor-lib           Censor warnings from library sources\n  --censor-src           Censor warnings from project sources\n  --censor-codes=CODES   Censor specific error codes\n  --filter-codes=CODES   Only show specific error codes\n  --no-colors            Disable ANSI colors\n  --no-source            Disable original source code printing\n  --strict               Promotes src warnings to errors\n  --stash                Enable persistent warnings (defaults to .psa-stash)\n  --stash=FILE           Enable persistent warnings using a specific stash file\n  --is-lib=DIR           Distinguishing library path (defaults to 'bower_components')\n  --psc=PSC              Name of psc executable (defaults to 'psc')\n\n  CODES                  Comma-separated list of psc error codes\n  PSC_OPTIONS            Any extra options are passed to psc\n";
var parseOptions = function (opts) {
    return function (args) {
        var isPrefix = function (s) {
            return function (str) {
                var $25 = Data_String.indexOf(s)(str);
                if ($25 instanceof Data_Maybe.Just && $25.value0 === 0) {
                    return true;
                };
                return false;
            };
        };
        var parse = function (p) {
            return function (arg) {
                if (arg === "--version" || arg === "-v") {
                    return Control_Apply.applySecond(Control_Monad_Eff.applyEff)(Control_Monad_Eff_Console.log($foreign.version))(Node_Process.exit(0));
                };
                if (arg === "--help" || arg === "-h") {
                    return Control_Apply.applySecond(Control_Monad_Eff.applyEff)(Control_Monad_Eff_Console.log(usage))(Node_Process.exit(0));
                };
                if (arg === "--stash") {
                    return Control_Applicative.pure(Control_Monad_Eff.applicativeEff)((function () {
                        var $29 = {};
                        for (var $30 in p) {
                            if (p.hasOwnProperty($30)) {
                                $29[$30] = p[$30];
                            };
                        };
                        $29.stash = true;
                        return $29;
                    })());
                };
                if (arg === "--json-errors") {
                    return Control_Applicative.pure(Control_Monad_Eff.applicativeEff)((function () {
                        var $32 = {};
                        for (var $33 in p) {
                            if (p.hasOwnProperty($33)) {
                                $32[$33] = p[$33];
                            };
                        };
                        $32.jsonErrors = true;
                        return $32;
                    })());
                };
                if (arg === "--no-source") {
                    return Control_Applicative.pure(Control_Monad_Eff.applicativeEff)((function () {
                        var $35 = {};
                        for (var $36 in p) {
                            if (p.hasOwnProperty($36)) {
                                $35[$36] = p[$36];
                            };
                        };
                        $35.showSource = false;
                        return $35;
                    })());
                };
                if (arg === "--no-colors" || arg === "--monochrome") {
                    return Control_Applicative.pure(Control_Monad_Eff.applicativeEff)((function () {
                        var $41 = {};
                        for (var $42 in p) {
                            if (p.hasOwnProperty($42)) {
                                $41[$42] = p[$42];
                            };
                        };
                        $41.opts = (function () {
                            var $38 = {};
                            for (var $39 in p.opts) {
                                if (p.opts.hasOwnProperty($39)) {
                                    $38[$39] = p.opts[$39];
                                };
                            };
                            $38.ansi = false;
                            return $38;
                        })();
                        return $41;
                    })());
                };
                if (arg === "--verbose-stats") {
                    return Control_Applicative.pure(Control_Monad_Eff.applicativeEff)((function () {
                        var $47 = {};
                        for (var $48 in p) {
                            if (p.hasOwnProperty($48)) {
                                $47[$48] = p[$48];
                            };
                        };
                        $47.opts = (function () {
                            var $44 = {};
                            for (var $45 in p.opts) {
                                if (p.opts.hasOwnProperty($45)) {
                                    $44[$45] = p.opts[$45];
                                };
                            };
                            $44.verboseStats = true;
                            return $44;
                        })();
                        return $47;
                    })());
                };
                if (arg === "--strict") {
                    return Control_Applicative.pure(Control_Monad_Eff.applicativeEff)((function () {
                        var $53 = {};
                        for (var $54 in p) {
                            if (p.hasOwnProperty($54)) {
                                $53[$54] = p[$54];
                            };
                        };
                        $53.opts = (function () {
                            var $50 = {};
                            for (var $51 in p.opts) {
                                if (p.opts.hasOwnProperty($51)) {
                                    $50[$51] = p.opts[$51];
                                };
                            };
                            $50.strict = true;
                            return $50;
                        })();
                        return $53;
                    })());
                };
                if (arg === "--censor-warnings") {
                    return Control_Applicative.pure(Control_Monad_Eff.applicativeEff)((function () {
                        var $59 = {};
                        for (var $60 in p) {
                            if (p.hasOwnProperty($60)) {
                                $59[$60] = p[$60];
                            };
                        };
                        $59.opts = (function () {
                            var $56 = {};
                            for (var $57 in p.opts) {
                                if (p.opts.hasOwnProperty($57)) {
                                    $56[$57] = p.opts[$57];
                                };
                            };
                            $56.censorWarnings = true;
                            return $56;
                        })();
                        return $59;
                    })());
                };
                if (arg === "--censor-lib") {
                    return Control_Applicative.pure(Control_Monad_Eff.applicativeEff)((function () {
                        var $65 = {};
                        for (var $66 in p) {
                            if (p.hasOwnProperty($66)) {
                                $65[$66] = p[$66];
                            };
                        };
                        $65.opts = (function () {
                            var $62 = {};
                            for (var $63 in p.opts) {
                                if (p.opts.hasOwnProperty($63)) {
                                    $62[$63] = p.opts[$63];
                                };
                            };
                            $62.censorLib = true;
                            return $62;
                        })();
                        return $65;
                    })());
                };
                if (arg === "--censor-lib") {
                    return Control_Applicative.pure(Control_Monad_Eff.applicativeEff)((function () {
                        var $71 = {};
                        for (var $72 in p) {
                            if (p.hasOwnProperty($72)) {
                                $71[$72] = p[$72];
                            };
                        };
                        $71.opts = (function () {
                            var $68 = {};
                            for (var $69 in p.opts) {
                                if (p.opts.hasOwnProperty($69)) {
                                    $68[$69] = p.opts[$69];
                                };
                            };
                            $68.censorLib = true;
                            return $68;
                        })();
                        return $71;
                    })());
                };
                if (arg === "--censor-src") {
                    return Control_Applicative.pure(Control_Monad_Eff.applicativeEff)((function () {
                        var $77 = {};
                        for (var $78 in p) {
                            if (p.hasOwnProperty($78)) {
                                $77[$78] = p[$78];
                            };
                        };
                        $77.opts = (function () {
                            var $74 = {};
                            for (var $75 in p.opts) {
                                if (p.opts.hasOwnProperty($75)) {
                                    $74[$75] = p.opts[$75];
                                };
                            };
                            $74.censorSrc = true;
                            return $74;
                        })();
                        return $77;
                    })());
                };
                if (isPrefix("--censor-codes=")(arg)) {
                    return Control_Applicative.pure(Control_Monad_Eff.applicativeEff)((function () {
                        var $83 = {};
                        for (var $84 in p) {
                            if (p.hasOwnProperty($84)) {
                                $83[$84] = p[$84];
                            };
                        };
                        $83.opts = (function () {
                            var $80 = {};
                            for (var $81 in p.opts) {
                                if (p.opts.hasOwnProperty($81)) {
                                    $80[$81] = p.opts[$81];
                                };
                            };
                            $80.censorCodes = Data_Foldable.foldr(Data_Foldable.foldableArray)(Data_Set.insert(Data_Ord.ordString))(p.opts.censorCodes)(Data_String.split(",")(Data_String.drop(15)(arg)));
                            return $80;
                        })();
                        return $83;
                    })());
                };
                if (isPrefix("--filter-codes=")(arg)) {
                    return Control_Applicative.pure(Control_Monad_Eff.applicativeEff)((function () {
                        var $89 = {};
                        for (var $90 in p) {
                            if (p.hasOwnProperty($90)) {
                                $89[$90] = p[$90];
                            };
                        };
                        $89.opts = (function () {
                            var $86 = {};
                            for (var $87 in p.opts) {
                                if (p.opts.hasOwnProperty($87)) {
                                    $86[$87] = p.opts[$87];
                                };
                            };
                            $86.filterCodes = Data_Foldable.foldr(Data_Foldable.foldableArray)(Data_Set.insert(Data_Ord.ordString))(p.opts.filterCodes)(Data_String.split(",")(Data_String.drop(15)(arg)));
                            return $86;
                        })();
                        return $89;
                    })());
                };
                if (isPrefix("--is-lib=")(arg)) {
                    return Control_Applicative.pure(Control_Monad_Eff.applicativeEff)((function () {
                        var $95 = {};
                        for (var $96 in p) {
                            if (p.hasOwnProperty($96)) {
                                $95[$96] = p[$96];
                            };
                        };
                        $95.opts = (function () {
                            var $92 = {};
                            for (var $93 in p.opts) {
                                if (p.opts.hasOwnProperty($93)) {
                                    $92[$93] = p.opts[$93];
                                };
                            };
                            $92.libDirs = Data_Array.snoc(p.opts.libDirs)(Data_String.drop(9)(arg));
                            return $92;
                        })();
                        return $95;
                    })());
                };
                if (isPrefix("--psc=")(arg)) {
                    return Control_Applicative.pure(Control_Monad_Eff.applicativeEff)((function () {
                        var $98 = {};
                        for (var $99 in p) {
                            if (p.hasOwnProperty($99)) {
                                $98[$99] = p[$99];
                            };
                        };
                        $98.psc = Data_String.drop(6)(arg);
                        return $98;
                    })());
                };
                if (isPrefix("--stash=")(arg)) {
                    return Control_Applicative.pure(Control_Monad_Eff.applicativeEff)((function () {
                        var $101 = {};
                        for (var $102 in p) {
                            if (p.hasOwnProperty($102)) {
                                $101[$102] = p[$102];
                            };
                        };
                        $101.stash = true;
                        $101.stashFile = Data_String.drop(8)(arg);
                        return $101;
                    })());
                };
                if (Data_Boolean.otherwise) {
                    return Control_Applicative.pure(Control_Monad_Eff.applicativeEff)((function () {
                        var $104 = {};
                        for (var $105 in p) {
                            if (p.hasOwnProperty($105)) {
                                $104[$105] = p[$105];
                            };
                        };
                        $104.extra = Data_Array.snoc(p.extra)(arg);
                        return $104;
                    })());
                };
                throw new Error("Failed pattern match at Main line 74, column 1 - line 149, column 20: " + [ p.constructor.name, arg.constructor.name ]);
            };
        };
        var defaultLibDir = function (x) {
            if (Data_Array.length(x.opts.libDirs) === 0) {
                var $111 = {};
                for (var $112 in x) {
                    if (x.hasOwnProperty($112)) {
                        $111[$112] = x[$112];
                    };
                };
                $111.opts = (function () {
                    var $108 = {};
                    for (var $109 in x.opts) {
                        if (x.opts.hasOwnProperty($109)) {
                            $108[$109] = x.opts[$109];
                        };
                    };
                    $108.libDirs = [ "bower_components" ];
                    return $108;
                })();
                return $111;
            };
            if (Data_Boolean.otherwise) {
                return x;
            };
            throw new Error("Failed pattern match at Main line 74, column 1 - line 149, column 20: " + [ x.constructor.name ]);
        };
        return Data_Functor.map(Control_Monad_Eff.functorEff)(defaultLibDir)(Data_Array.foldM(Control_Monad_Eff.monadEff)(parse)({
            extra: [  ], 
            psc: "psc", 
            showSource: true, 
            stash: false, 
            stashFile: ".psa-stash", 
            jsonErrors: false, 
            opts: opts
        })(args));
    };
};
var defaultOptions = {
    ansi: true, 
    censorWarnings: false, 
    censorLib: false, 
    censorSrc: false, 
    censorCodes: Data_Set.empty, 
    filterCodes: Data_Set.empty, 
    verboseStats: false, 
    libDirs: [  ], 
    strict: false, 
    cwd: ""
};

/**
 *  Due to `catchException` label annoyingness
 */
var catchException$prime = function (eb) {
    return function (eff) {
        return Unsafe_Coerce.unsafeCoerce(Control_Monad_Eff_Exception.catchException(Unsafe_Coerce.unsafeCoerce(eb))(Unsafe_Coerce.unsafeCoerce(eff)));
    };
};
var main = (function () {
    
    /**
     *  TODO: Handle exceptions
     */
    var stdio = [ new Data_Maybe.Just(Node_ChildProcess.Pipe.value), Partial_Unsafe.unsafePartial(function (dictPartial) {
        return Node_ChildProcess.inherit[1];
    }), new Data_Maybe.Just(Node_ChildProcess.Pipe.value) ];
    var spawn$prime = function (cmd) {
        return function (args) {
            return function (onExit) {
                return function __do() {
                    var v = Node_ChildProcess.spawn(cmd)(args)((function () {
                        var $114 = {};
                        for (var $115 in Node_ChildProcess.defaultSpawnOptions) {
                            if (Node_ChildProcess.defaultSpawnOptions.hasOwnProperty($115)) {
                                $114[$115] = Node_ChildProcess.defaultSpawnOptions[$115];
                            };
                        };
                        $114.stdio = stdio;
                        return $114;
                    })())();
                    var v1 = Control_Monad_ST.newSTRef("")();
                    Node_Stream.onDataString(Node_ChildProcess.stderr(v))(Node_Encoding.UTF8.value)(function (chunk) {
                        return Data_Functor["void"](Control_Monad_Eff.functorEff)(Control_Monad_ST.modifySTRef(v1)(function (v2) {
                            return v2 + chunk;
                        }));
                    })();
                    Node_ChildProcess.onExit(v)(function (status) {
                        if (status instanceof Node_ChildProcess.Normally) {
                            return function __do() {
                                Control_Bind.bind(Control_Monad_Eff.bindEff)(Control_Monad_ST.readSTRef(v1))(onExit)();
                                return Node_Process.exit(status.value0)();
                            };
                        };
                        if (status instanceof Node_ChildProcess.BySignal) {
                            return function __do() {
                                Control_Monad_Eff_Console.error(Data_Show.show(Data_Posix_Signal.showSignal)(status.value0))();
                                return Node_Process.exit(1)();
                            };
                        };
                        throw new Error("Failed pattern match at Main line 215, column 7 - line 222, column 5: " + [ status.constructor.name ]);
                    })();
                    return Node_ChildProcess.onError(v)(retryWithCmd(cmd)(args)(onExit))();
                };
            };
        };
    };
    var retryWithCmd = function (cmd) {
        return function (args) {
            return function (onExit) {
                return function (err) {
                    if (err.code === "ENOENT") {
                        var $126 = Data_Eq.eq(Node_Platform.eqPlatform)(Node_Process.platform)(Node_Platform.Win32.value);
                        if ($126) {
                            var $127 = Data_String.stripSuffix(".cmd")(cmd);
                            if ($127 instanceof Data_Maybe.Nothing) {
                                return spawn$prime(cmd + ".cmd")(args)(onExit);
                            };
                            if ($127 instanceof Data_Maybe.Just) {
                                return Control_Monad_Eff_Exception["throw"]("`" + ($127.value0 + ("` executable not found. (nor `" + (cmd + "`)"))));
                            };
                            throw new Error("Failed pattern match at Main line 229, column 10 - line 232, column 8: " + [ $127.constructor.name ]);
                        };
                        if (!$126) {
                            return Control_Monad_Eff_Exception["throw"]("`" + (cmd + "` executable not found."));
                        };
                        throw new Error("Failed pattern match at Main line 227, column 6 - line 234, column 5: " + [ $126.constructor.name ]);
                    };
                    if (Data_Boolean.otherwise) {
                        return Control_Monad_Eff_Exception.throwException(Node_ChildProcess.toStandardError(err));
                    };
                    throw new Error("Failed pattern match at Main line 164, column 1 - line 281, column 23: " + [ cmd.constructor.name, args.constructor.name, onExit.constructor.name, err.constructor.name ]);
                };
            };
        };
    };
    var mergeWarnings = function (filenames) {
        return function (date) {
            return function (old) {
                return function ($$new) {
                    return function __do() {
                        var v = Data_StrMap_ST["new"]();
                        var v1 = Data_Function.flip(Data_Array.filterM(Control_Monad_Eff.monadEff))(old)(function (x) {
                            if (x.filename instanceof Data_Maybe.Nothing) {
                                return Control_Applicative.pure(Control_Monad_Eff.applicativeEff)(false);
                            };
                            if (x.filename instanceof Data_Maybe.Just) {
                                var $131 = Data_Set.member(Data_Ord.ordString)(x.filename.value0)(filenames);
                                if ($131) {
                                    return Control_Applicative.pure(Control_Monad_Eff.applicativeEff)(false);
                                };
                                if (!$131) {
                                    return function __do() {
                                        var v1 = Data_StrMap_ST.peek(v)(x.filename.value0)();
                                        if (v1 instanceof Data_Maybe.Just) {
                                            return v1.value0;
                                        };
                                        if (v1 instanceof Data_Maybe.Nothing) {
                                            var v2 = catchException$prime(function (v2) {
                                                return Control_Applicative.pure(Control_Monad_Eff.applicativeEff)(false);
                                            })(Data_Functor.map(Control_Monad_Eff.functorEff)(function ($178) {
                                                return (function (v2) {
                                                    return Data_Ord.greaterThan(Data_DateTime.ordDateTime)(date)(v2);
                                                })(Node_FS_Stats.modifiedTime($178));
                                            })(Node_FS_Sync.stat(x.filename.value0)))();
                                            Data_StrMap_ST.poke(v)(x.filename.value0)(v2)();
                                            return v2;
                                        };
                                        throw new Error("Failed pattern match at Main line 274, column 15 - line 280, column 25: " + [ v1.constructor.name ]);
                                    };
                                };
                                throw new Error("Failed pattern match at Main line 270, column 11 - line 280, column 25: " + [ $131.constructor.name ]);
                            };
                            throw new Error("Failed pattern match at Main line 267, column 7 - line 280, column 25: " + [ x.filename.constructor.name ]);
                        })();
                        return Data_Semigroup.append(Data_Semigroup.semigroupArray)(v1)($$new);
                    };
                };
            };
        };
    };
    var loadNothing = function (v) {
        return function (v1) {
            return Control_Applicative.pure(Control_Monad_Eff.applicativeEff)(Data_Maybe.Nothing.value);
        };
    };
    var loadLines = function (files) {
        return function (filename) {
            return function (pos) {
                return function __do() {
                    var v = (function __do() {
                        var cache = Data_StrMap_ST.peek(files)(filename)();
                        if (cache instanceof Data_Maybe.Just) {
                            return cache.value0;
                        };
                        if (cache instanceof Data_Maybe.Nothing) {
                            var v = Data_Functor.map(Control_Monad_Eff.functorEff)(Data_String.split("\n"))(Node_FS_Sync.readTextFile(Node_Encoding.UTF8.value)(filename))();
                            Data_StrMap_ST.poke(files)(filename)(v)();
                            return v;
                        };
                        throw new Error("Failed pattern match at Main line 240, column 7 - line 245, column 21: " + [ cache.constructor.name ]);
                    })();
                    var source = Data_Array.slice(pos.startLine - 1)(pos.endLine)(v);
                    return new Data_Maybe.Just(source);
                };
            };
        };
    };
    var insertFilenames = Data_Foldable.foldr(Data_Foldable.foldableArray)(function (x) {
        return function (s) {
            return Data_Maybe.maybe(s)(Data_Function.flip(Data_Set.insert(Data_Ord.ordString))(s))(x.filename);
        };
    });
    var encodeStash = function (s) {
        return Data_Argonaut_Encode_Class.encodeJson(Data_Argonaut_Encode_Class.encodeJsonArray(Data_Argonaut_Encode_Class.encodeJsonJson))(Data_Functor.map(Data_Functor.functorArray)(Psa_Types.encodePsaError)(s));
    };
    var writeStashFile = function (stashFile) {
        return function (warnings) {
            var file = Data_Argonaut_Printer.printJson(Data_Argonaut_Printer.printerString)(encodeStash(warnings));
            return Node_FS_Sync.writeTextFile(Node_Encoding.UTF8.value)(stashFile)(file);
        };
    };
    var emptyStash = Data_Functor.map(Control_Monad_Eff.functorEff)(Data_Functor.map(Data_Functor.functorFn)(function (v) {
        return {
            date: v, 
            stash: [  ]
        };
    })(Data_DateTime_Instant.toDateTime))(Control_Monad_Eff_Now.now);
    var decodeStash = function (s) {
        return Control_Bind.bind(Data_Either.bindEither)(Control_Bind.bind(Data_Either.bindEither)(Data_Argonaut_Parser.jsonParser(s))(Data_Argonaut_Decode_Class.decodeJson(Data_Argonaut_Decode_Class.decodeArray(Data_Argonaut_Decode_Class.decodeStrMap(Data_Argonaut_Decode_Class.decodeJsonJson)))))(Data_Traversable.traverse(Data_Traversable.traversableArray)(Data_Either.applicativeEither)(Psa_Types.parsePsaError));
    };
    var readStashFile = function (stashFile) {
        return catchException$prime(Data_Function["const"](emptyStash))(function __do() {
            var v = Node_FS_Sync.stat(stashFile)();
            var v1 = Node_FS_Sync.readTextFile(Node_Encoding.UTF8.value)(stashFile)();
            var $145 = decodeStash(v1);
            if ($145 instanceof Data_Either.Left) {
                return emptyStash();
            };
            if ($145 instanceof Data_Either.Right) {
                return {
                    date: Node_FS_Stats.modifiedTime(v), 
                    stash: $145.value0
                };
            };
            throw new Error("Failed pattern match at Main line 256, column 5 - line 258, column 67: " + [ $145.constructor.name ]);
        });
    };
    return Data_Functor["void"](Control_Monad_Eff.functorEff)(function __do() {
        var v = Node_Process.cwd();
        var v1 = Data_Functor.map(Control_Monad_Eff.functorEff)(Data_Array.drop(2))(Node_Process.argv)();
        var v2 = parseOptions((function () {
            var $150 = {};
            for (var $151 in defaultOptions) {
                if (defaultOptions.hasOwnProperty($151)) {
                    $150[$151] = defaultOptions[$151];
                };
            };
            $150.cwd = v;
            return $150;
        })())(v1)();
        var opts$prime = (function () {
            var $154 = {};
            for (var $155 in v2.opts) {
                if (v2.opts.hasOwnProperty($155)) {
                    $154[$155] = v2.opts[$155];
                };
            };
            $154.libDirs = Data_Functor.map(Data_Functor.functorArray)(function ($179) {
                return (function (v3) {
                    return v3 + Node_Path.sep;
                })(Node_Path.resolve([ v ])($179));
            })(v2.opts.libDirs);
            return $154;
        })();
        var args = Data_Array.cons("--json-errors")(v2.extra);
        var v3 = (function () {
            if (v2.stash) {
                return readStashFile(v2.stashFile);
            };
            if (!v2.stash) {
                return emptyStash;
            };
            throw new Error("Failed pattern match at Main line 181, column 5 - line 183, column 22: " + [ v2.stash.constructor.name ]);
        })()();
        return spawn$prime(v2.psc)(args)(function (buffer) {
            var stderr = Data_String.split("\n")(buffer);
            return Data_Foldable.for_(Control_Monad_Eff.applicativeEff)(Data_Foldable.foldableArray)(stderr)(function (err) {
                var $159 = Control_Bind.bind(Data_Either.bindEither)(Control_Bind.bind(Data_Either.bindEither)(Data_Argonaut_Parser.jsonParser(err))(Data_Argonaut_Decode_Class.decodeJson(Data_Argonaut_Decode_Class.decodeStrMap(Data_Argonaut_Decode_Class.decodeJsonJson))))(Psa_Types.parsePsaResult);
                if ($159 instanceof Data_Either.Left) {
                    return Control_Monad_Eff_Console.error(err);
                };
                if ($159 instanceof Data_Either.Right) {
                    return function __do() {
                        var v4 = Data_StrMap_ST["new"]();
                        var loadLinesImpl = (function () {
                            if (v2.showSource) {
                                return loadLines(v4);
                            };
                            if (!v2.showSource) {
                                return loadNothing;
                            };
                            throw new Error("Failed pattern match at Main line 192, column 31 - line 192, column 82: " + [ v2.showSource.constructor.name ]);
                        })();
                        var filenames = insertFilenames(insertFilenames(Data_Set.empty)($159.value0.errors))($159.value0.warnings);
                        var v5 = mergeWarnings(filenames)(v3.date)(v3.stash)($159.value0.warnings)();
                        Control_Applicative.when(Control_Monad_Eff.applicativeEff)(v2.stash)(writeStashFile(v2.stashFile)(v5))();
                        var v6 = Psa_Output.output(Control_Monad_Eff.monadEff)(loadLinesImpl)(opts$prime)((function () {
                            var $164 = {};
                            for (var $165 in $159.value0) {
                                if ($159.value0.hasOwnProperty($165)) {
                                    $164[$165] = $159.value0[$165];
                                };
                            };
                            $164.warnings = v5;
                            return $164;
                        })())();
                        (function () {
                            if (v2.jsonErrors) {
                                return Psa_Printer_Json.print(v6);
                            };
                            if (!v2.jsonErrors) {
                                return Psa_Printer_Default.print(opts$prime)(v6);
                            };
                            throw new Error("Failed pattern match at Main line 197, column 11 - line 199, column 49: " + [ v2.jsonErrors.constructor.name ]);
                        })()();
                        var $169 = Data_StrMap.isEmpty(v6.stats.allErrors);
                        if ($169) {
                            return Node_Process.exit(0)();
                        };
                        if (!$169) {
                            return Node_Process.exit(1)();
                        };
                        throw new Error("Failed pattern match at Main line 200, column 11 - line 204, column 3: " + [ $169.constructor.name ]);
                    };
                };
                throw new Error("Failed pattern match at Main line 188, column 7 - line 204, column 3: " + [ $159.constructor.name ]);
            });
        })();
    });
})();
module.exports = {
    "catchException'": catchException$prime, 
    defaultOptions: defaultOptions, 
    main: main, 
    parseOptions: parseOptions, 
    usage: usage, 
    version: $foreign.version
};
